<?php
rg_log("/inc/repo/repo");

$repo_more = $more;
$_repo = "";

if ($login_ui['uid'] == 0) {
	$_repo .= rg_warning("You do not have access here!");
	return;
}

$name = rg_var_str("name");
$max_commit_size = rg_var_uint("max_commit_size");
$max_users = rg_var_uint("max_users");
$description = rg_var_str("description");
$master_repo_id = rg_var_uint("master_repo_id");
$rights = isset($_REQUEST['rights']) ? rg_rights_a2s(rg_var_str("rights")) : $rg_repo_rights_default;
$repo_id = rg_var_uint("repo_id");

$errmsg = array();

$_subop = empty($paras) ? "list" : array_shift($paras);

// menu
$_m = array(
	"list" => array(
		"text" => "List",
		"op" => "list"
		),
	"create" => array(
		"text" => "Create",
		"op" => "create"
		),
	"search" => array(
		"text" => "Search",
		"op" => "search"
		)
);
rg_menu_add($rg_menu, $_m, $_subop);

switch ($_subop) {
case 'list':
	$_repo .= rg_repo_list($db, "", $login_ui);
	break;

case 'create':
	while ($doit == 1) {
		$_r = rg_repo_create($db, $master_repo_id, $login_ui, $name,
			$max_commit_size, $description, $rights, $max_users);
		if ($_r === FALSE) {
			$errmsg[] = rg_repo_error();
			break;
		}

		// redirect to repo page
		$url = rg_re_repopage($login_ui, $name);
		rg_redirect($url);
	}

	if ($master_repo_id > 0) {
		$master_name = $master_repo_id;
		$_mi = repo_info($db, $master_repo_id, "");
		if ($_mi['exists'] == 1)
			$master_name = $_mi['name'];
		$repo_more['master_name'] = $master_name;
	} else {
		$repo_more['master_name'] = "";
	}

	$repo_more['title'] = "Create repository";
	$repo_more['button'] = "Create";
	$repo_more['name'] = $name;
	$repo_more['max_commit_size'] = $max_commit_size;
	$repo_more['max_users'] = $max_users;
	$repo_more['description'] = $description;
	$repo_more['master_repo_id'] = $master_repo_id;
	$repo_more['HTML:rights'] = rg_rights_checkboxes("repo", $rights);
	$repo_more['repo_id'] = $repo_id;
	$repo_more['HTML:errmsg'] = rg_template_errmsg($errmsg);
	$repo_more['rg_form_token'] = rg_token_get($db, $sid);
	$_repo .= rg_template("repo/add_edit.html", $repo_more);
	break;

case 'search':
	$q = rg_var_str("q");

	while ($doit == 1) {
		$_t = rg_repo_search($db, $login_ui, $q);
		if ($_t === FALSE) {
			$errmsg[] = rg_repo_error();
			break;
		}

		$_repo .= $_t;
		break;
	}

	$repo_more['q'] = $q;
	$repo_more['HTML:errmsg'] = rg_template_errmsg($errmsg);
	$_repo .= rg_template("repo/search.html", $repo_more);
	break;
}

?>
