<?php
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/token.inc.php");
require_once($INC . "/prof.inc.php");

/*
 * Add a session
 */
function rg_sess_add($db, $uid, $sid, $session_time)
{
	rg_prof_start("sess_add");

	rg_log("sess_add: uid=$uid, sid=$sid, session_time=$session_time.");

	$ip = @$_SERVER['REMOTE_ADDR'];
	$now = time();

	$sql = "INSERT INTO sess (sid, uid, expire, session_time, ip)"
		. " VALUES ('$sid', $uid"
		. ", " . ($now + $session_time) . ", $session_time, '$ip')";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_log("\tCannot insert (" . rg_sql_error() . ")!");
		return FALSE;
	}
	rg_sql_free_result($res);

	rg_prof_end("sess_add");

	return TRUE;
}

/*
 * Returns if a session is still valid. Will return FALSE or uid
 */
function rg_sess_valid($db, $sid)
{
	rg_prof_start("sess_valid");

	rg_log("sess_valid: sid=$sid...");

	$uid = FALSE;

	$e_sid = rg_sql_escape($db, $sid);

	$sql = "SELECT uid, expire FROM sess WHERE sid = '$e_sid'";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_log("\tCannot select (" . rg_sql_error() . ")!");
		return FALSE;
	}
	$row = rg_sql_fetch_array($res);
	rg_sql_free_result($res);
	if (isset($row['uid'])) {
		$now = time();
		if ($row['expire'] >= $now) {
			$uid = $row['uid'];
			rg_log("\tSession valid, uid=$uid, expire=+" . ($row['expire'] - $now));
		} else {
			rg_log("\tSession too old (" . ($now - $row['expire']) . "s)");
		}
	} else {
		rg_log("\tSession not found!");
	}

	rg_prof_end("sess_valid");

	return $uid;
}

/*
 * Refresh a session
 */
function rg_sess_update($db, $sid)
{
	rg_prof_start("sess_update");

	rg_log("sess_update: sid=$sid...");

	$e_sid = rg_sql_escape($db, $sid);

	$sql = "UPDATE sess SET expire = " . time() . " + session_time"
		. " WHERE sid = '$e_sid'";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_log("\tCannot update (" . rg_sql_error() . ")!");
		return FALSE;
	}
	rg_sql_free_result($res);

	rg_prof_end("sess_update");

	return TRUE;
}

/*
 * Destroy session
 */
function rg_sess_destroy($db, $sid, &$ui)
{
	rg_prof_start("sess_destroy");

	rg_log("sess_destroy: sid=$sid...");

	$e_sid = rg_sql_escape($db, $sid);

	$sql = "DELETE FROM sess WHERE sid = '$e_sid'";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_log("\tCannot delete (" . rg_sql_error() . ")!");
		return FALSE;
	}
	rg_sql_free_result($res);

	// Delete all tokens associated with this session
	rg_token_delete($db, $sid, "");

	$ui = array();
	$ui['uid'] = 0;
	$ui['is_admin'] = 0;

	rg_prof_end("sess_destroy");

	return TRUE;
}

?>
