<?php
require_once($INC . "/util.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");

$rg_token_error = "";

function rg_token_set_error($str)
{
	global $rg_token_error;
	$rg_token_error = $str;
}

function rg_token_error()
{
	global $rg_token_error;
	return $rg_token_error;
}

/*
 * Delete a token
 */
function rg_token_delete($db, $sid, $token)
{
	rg_log("rg_token_delete: sid=$sid token=$token");

	$ret = array();
	$ret['ok'] = 0;

	$add_token = "";
	if (!empty($token))
		$add_token = " AND token = '$token'";

	$sql = "DELETE FROM tokens"
		. " WHERE sid = '$sid'"
		. $add_token;
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_token_set_error("cannot delete token (" . rg_sql_error() . ")");
		return $ret;
	}
	rg_sql_free_result($res);

	$ret['ok'] = 1;

	return $ret;
}

/*
 * Returns TRUE if the token is valid
 */
function rg_token_valid($db, $sid, $token)
{
	rg_log("rg_token_get: sid=$sid token=$token");

	$sql = "SELECT 1 AS junk FROM tokens"
		. " WHERE token = '$token'"
		. " AND sid = '$sid'";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_token_set_error("cannot get token (" . rg_sql_error() . ")");
		return FALSE;
	}

	$ret['ok'] = 1;
	$ret['exists'] = 0;
	$rows = rg_sql_num_rows($res);
	rg_sql_free_result($res);
	if ($rows == 0)
		return FALSE;

	return TRUE;
}

/*
 * Insert a token
 */
function rg_token_insert($db, $sid, $token)
{
	rg_log("rg_token_insert: sid=$sid token=$token");

	$ret = array();
	$ret['ok'] = 0;

	$now = time();

	$sql = "INSERT INTO tokens (sid, token, expire)"
		. " VALUES ('$sid', '$token', $now + 24 * 3600)";
	$res = rg_sql_query($db, $sql);
	if ($res === FALSE) {
		rg_token_set_error("cannot insert token (" . rg_sql_error() . ")!");
		return $ret;
	}

	$ret['ok'] = 1;
	return $ret;
}

/*
 * Returns a token to be used on a form/url
 * We generate only one per session.
 */
$rg_token = FALSE;
function rg_token_get($db, $sid)
{
	global $rg_token;

	if (empty($sid))
		return "";

	if ($rg_token === FALSE) {
		$rg_token = rg_id(16);

		rg_token_insert($db, $sid, $rg_token);
	}

	return $rg_token;
}

?>
