<?php
rg_log("/inc/user/repo/bug/show");

$repo_bug_show_more = $repo_bug_more;
$_bug_show = "";

$repo_bug_show_more['bug_id'] = $bug_id;
$repo_bug_show_more['HTML:bug_edit'] = "";

$ibug = rg_bug_info($db, $ri['repo_id'], $bug_id);
if ($ibug === FALSE)
	rg_fatal("Cannot lookup bug!");
if ($ibug['exists'] != 1) {
	$_bug_body .= rg_template("repo/bug/not_found.html", $repo_bug_show_more);
	return;
}

// load labels
$labels = rg_bug_label_get($db, $ri['repo_id'], $bug_id);
if ($labels === FALSE)
	$repo_bug_show_more['HTML:labels_html'] = "Cannot load labels!";
else
	$repo_bug_show_more['HTML:labels_html'] = rg_bug_label_html($db, $labels);
$repo_bug_show_more['labels'] = implode(" ", $labels);

// edit
$repo_bug_show_more['HTML:edit_form'] = rg_template("repo/bug/b_edit.html",
	$repo_bug_show_more);
if (rg_var_uint("edit") == 1) {
	include($INC . "/user/repo/bug/show/edit.php");
	$repo_bug_show_more['HTML:bug_edit'] = $_bug_edit;
}

// close/re-open
$close_reopen_error = "";
while (rg_var_uint("close_reopen") == 1) {
	if (!rg_token_valid($db, $sid, $token)) {
		$close_reopen_error = "Invalid token. Try again.";
		break;
	}

	$ibug['state'] = rg_var_uint("state");
	$ibug['state_text'] = rg_bug_state($ibug['state']);
	$ret = rg_bug_edit($db, $ri, $login_ui, $ibug);
	if ($ret === FALSE) {
		$close_reopen_error = "Cannot edit bug (" . rg_bug_error() . ")";
		break;
	}

	// TODO: do something with the error code
	break;
}
if ($ibug['state'] == 1)
	$t = "repo/bug/b_close.html";
else
	$t = "repo/bug/b_reopen.html";
$repo_bug_show_more['HTML:close_form'] = rg_template($t, $repo_bug_show_more);
$repo_bug_show_more['HTML:button_error'] = rg_warning($close_reopen_error,
	$repo_bug_show_more);

// add_note must be unconditionally included because we must insert the form
include($INC . "/user/repo/bug/show/add_note.php");

// load notes
$notes = rg_bug_note_list($db, $ri['repo_id'], $bug_id, 0);
if ($notes === FALSE)
	$repo_bug_show_more['HTML:notes'] = "Cannot load notes!";
else
	$repo_bug_show_more['HTML:notes'] = rg_template_table("repo/bug/list_note", $notes, $repo_bug_show_more);

// watch
$watch_body = "";
$watch = rg_watch_load($db, 'B', $login_ui['uid'], $bug_id);
if ($watch === FALSE) {
	$watch_body .= rg_warning("Internal error.");
} else {
	if ($watch === 0) {
		// user does not watch the bug, present 'watch' form
		if (rg_var_uint("watch") == 1) {
			// user pressed watch button
			$r = rg_watch_add($db, 'B', $login_ui['uid'], $bug_id);
			if ($r === FALSE)
				rg_internal_error("TODO: find something here");
			$watch = 1;
		}
	} else {
		// user is already watching the bug, present 'unwatch' option
		if (rg_var_uint("unwatch") == 1) {
			// user pressed unwatch button
			$r = rg_watch_del($db, 'B', $login_ui['uid'], $bug_id);
			if ($r === FALSE)
				rg_internal_error("TODO: find something here");
			$watch = 0;
		}
	}

	if ($watch == 0)
		$t = "repo/bug/b_watch.html";
	else
		$t = "repo/bug/b_unwatch.html";

	$r = rg_template($t, $repo_bug_show_more);
	if ($r !== FALSE)
		$watch_body .= $r;
}
$repo_bug_show_more['HTML:watch_form'] = $watch_body;

//rg_log_ml("DEBUG: ibug: " . print_r($ibug, TRUE));
$repo_bug_show_more = array_merge($repo_bug_show_more, $ibug);
$repo_bug_show_more['rg_form_token'] = rg_token_get($db, $sid);

$_bug_show .= rg_template("repo/bug/show.html", $repo_bug_show_more);
?>
