%global selinux_types %(%{__awk} '/^#[[:space:]]*SELINUXTYPE=/,/^[^#]/ { if ($3 == "-") printf "%s ", $2 }' /etc/selinux/config 2>/dev/null)
%global selinux_variants %([ -z "%{selinux_types}" ] && echo mls strict targeted || echo %{selinux_types})
%global selinux_policyver %(%{__sed} -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp || echo 0.0.0)

Summary:	Light and fast Git hosting solution
Name:		rocketgit
Version:	0.16
Release:	1
License:	GPLv3
Group:		Development/Tools
Source:		http://kernel.embedromix.ro/us/rocketgit/%{name}-%{version}.tar.gz
URL:		http://kernel.embedromix.ro/us/
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
BuildArch:	noarch
Requires:	httpd, php, php-cli, php-pgsql, php-gd, xinetd
Requires(pre):	shadow-utils
Requires:	git, postgresql-server
Requires:	util-linux
# SELinux stuff
# https://fedoraproject.org/wiki/SELinux_Policy_Modules_Packaging_Draft?rd=PackagingDrafts/SELinux/PolicyModules
BuildRequires:	checkpolicy, selinux-policy-devel, hardlink
BuildRequires:	/usr/share/selinux/devel/policyhelp
%if "%{selinux_policyver}" != ""
Requires:	selinux-policy >= %{selinux_policyver}
%endif
Requires(post):	/usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles
Requires(postun):	/usr/sbin/semodule, /sbin/restorecon, /sbin/fixfiles

%description
Light and fast Git hosting solution, similar with Gitorious/etc.

%pre
getent group rocketgit >/dev/null || groupadd -r rocketgit
getent passwd rocketgit >/dev/null || useradd -r -g rocketgit -s /bin/bash -m -d /home/rocketgit -c "RocketGit user" rocketgit

%post
for type in %{selinux_variants}
do
	/usr/sbin/semodule -s ${type} -i \
		/usr/share/selinux/${type}/rocketgit.pp &> /dev/null || :
done
/sbin/fixfiles -R rocketgit restore || :

if [ $1 -ne 0 ]; then
	/sbin/service xinetd reload &>/dev/null || :
	/sbin/service httpd reload &>/dev/null || :
fi

%postun
if [ $1 = 0 ]; then
	for type in %{selinux_variants}
	do
		/usr/sbin/semodule -s ${type} -r rocketgit.pp &> /dev/null || :
	done
	/sbin/fixfiles -R rocketgit restore || :
fi

%prep
%setup -q

%build
%configure
# TODO: should we do this in configure?!
make selinux_variants="%{selinux_variants}"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr (-,root,root,0755)
%dir /usr/share/rocketgit
%doc README LICENSE Changelog TODO selinux/rocketgit.*
%dir /etc/rocketgit
%config(noreplace) /etc/rocketgit/config.php
/etc/rocketgit/config.php.sample
/etc/cron.d/rocketgit
/etc/logrotate.d/rocketgit
%config(noreplace) /etc/xinetd.d/rocketgit
%config(noreplace) /etc/httpd/conf.d/rocketgit.conf
%attr(0700,rocketgit,rocketgit) %dir /var/log/rocketgit
%attr(0700,apache,apache) %dir /var/log/rocketgit-web
%attr(0755,rocketgit,rocketgit) %dir /var/lib/rocketgit
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit/locks
%attr(0755,rocketgit,rocketgit) %dir /var/lib/rocketgit/repos
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit/q_merge_requests
%attr(0755,rocketgit,rocketgit) %dir /var/lib/rocketgit/sockets
/usr/share/rocketgit/*
/usr/share/selinux/*/rocketgit.pp

%changelog
* Wed Oct 17 2012 Catalin(ux) M. BOIE <catab at embedromix dor ro> 0.10
Alpha1 version released with a lot of fixes and some features.

* Mon Jun 27 2011 Catalin(ux) M. BOIE <catab at embedromix dot ro> 0.2
Another round of bulk changes.
