#!/bin/bash

# This is a wrapper for events.php, to not wait a lot after it exists

exec 100<>/var/lib/rocketgit/locks/events.lock

flock --exclusive --nonblock 100
if [ "${?}" != "0" ]; then
	exit 0
fi

while [ 1 ]; do
	php /usr/share/rocketgit/scripts/events.php

	# in case of errors, we will wait, to not go into an infinite loop
	if [ "${?}" != "0" ]; then
		sleep 30
	fi
done

flock --unlock 100
