<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = "../inc";
require_once($INC . "/init.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");

rg_log_set_file("sql.log");

// Defaults
$rg_admin_email = "rg@embedromix.ro";

echo "db: open connection...\n";
$db = rg_sql_open("dbname=trg");
if ($db === FALSE) {
	echo "Cannot create a database (" . rg_sql_error() . ")!\n";
	exit(1);
}

echo "db: drop 'test' table...\n";
$sql = "DROP TABLE IF EXISTS test";
$res = rg_sql_query($db, $sql);
if ($res === FALSE) {
	echo "Cannot create table 'test' (" . rg_sql_error() . ")!\n";
	exit(1);
}

echo "db: test creation of a table...\n";
$sql = "CREATE TABLE test (id TEXT PRIMARY KEY)";
$res = rg_sql_query($db, $sql);
if ($res === FALSE) {
	echo "Cannot create table 'test' (" . rg_sql_error() . ")!\n";
	exit(1);
}

echo "db: test insert...\n";
$sql = "INSERT INTO test (id) VALUES ('aaa')";
$res = rg_sql_query($db, $sql);
if ($res === FALSE) {
	echo "Cannot insert!\n";
	exit(1);
}

echo "db: test insert with the same key...\n";
$sql = "INSERT INTO test (id) VALUES ('aaa')";
$res = @rg_sql_query($db, $sql);
if ($res !== FALSE) {
	echo "I can do double insert!\n";
	exit(1);
}

echo "db: test delete...\n";
$sql = "DELETE FROM test WHERE id = 'aaa'";
$res = rg_sql_query($db, $sql);
if ($res === FALSE) {
	echo "Cannot delete!\n";
	exit(1);
}

// TODO: test rg_sql_last_id

rg_sql_close($db);

echo "db: OK!\n";
?>
